#ifndef _CLIENT_H
#define _CLIENT_H

#include <sys/types.h> /* for off_t */

#ifndef __P
#  ifdef __STDC__
#    define __P(p) p
#  else
#    define __P(p) ()
#  endif
#endif

extern int format __P((char *, char *, char *, int));
extern char * path_filter __P((char *, char *));
extern int  parsecmd __P((char *, CLIENT *));
extern caddr_t list __P((char *, char *, off_t *));

extern int  client_del __P((CLIENT *));
extern int  client_write __P((CLIENT *));
extern int  client_reply __P((CLIENT *));
extern int  reply __P((CLIENT *, char *, ...));
extern CLIENT * client_add __P((int, CLIENT **, SERVER *));

/* when doing list, we allocated maps by page so
 * the allocate map may be larger the size
 */
#define MUNMAP(client) \
{ \
  off_t page, n; \
  if (client->file.name != (char *)0) \
    munmap(client->file.cursor, client->file.size); \
  else \
  { \
    page = (off_t)getpagesize(); \
    n = (off_t)(client->file.size / page); \
    if (n == 0) \
      munmap(client->file.cursor, page); \
    else if ((n * page) < client->file.size) \
      munmap(client->file.cursor, (n + 1) * page); \
    else \
      munmap(client->file.cursor, n * page); \
  } \
  client->file.cursor = (caddr_t)-1; \
}

#endif  /* _CLIENT_H */
