#if __STDC__
#include <string.h> 
#else
#include <strings.h>
#endif
#include <stdio.h>
#ifdef __STDC__
#include <stdarg.h>
#else 
#include <varargs.h>
#endif
#include <errno.h>
#include <stdlib.h>

#include "yaftpd.h"
#include "log.h"

#define CNTL_BUF_SIZE 100

int
client_reply(client)
CLIENT * client;
{
  int err =0;

  LOG(L_FUNC, ("client_reply() call:"));
  if (client->reply.msg == (char *)0)
  {
    client->reply.nwritten = client->reply.size;
    return err;
  }

/* try to write a chunk */
  if (client->reply.nwritten < client->reply.size)
  {
    off_t nwrite;
    nwrite = write(client->sock_con,
                   client->reply.msg + client->reply.nwritten,
                   client->reply.size - client->reply.nwritten);
    if (nwrite > 0)
      client->reply.nwritten += nwrite;
    else
      switch(errno)
      {
        case EAGAIN:
        case EINTR:
        break;
        default: /* error finish sending */
          client->reply.nwritten = client->reply.size;
          err--;
      }
  }

/* finish sending */
  if (client->reply.nwritten == client->reply.size)
  {
    if (client->reply.msg != (char *)NULL)
      free(client->reply.msg);
    client->reply.msg = (char *)NULL;
    client->reply.nwritten = client->reply.size = 0;
    client->state = client->ostate;
    err--;
  }
  return err;
}

int
#ifdef __STDC__
reply(CLIENT * client, char * fmt, ...)
#else
reply(va_alist)
va_dcl
#endif
{
#ifndef __STDC__
  CLIENT * client;
  char * fmt;    /* print format */
#endif
  va_list args; /* argument list */

/* initialize argument list */
#ifndef __STDC__
  va_start(args);
  client = va_arg(args, CLIENT *);  /* client info */
  fmt = va_arg(args, char *);  /* format */
#else
  va_start(args, fmt);
#endif

  LOG(L_FUNC, ("reply() call:"));
/* display remaining args */ 
  if (client->reply.msg != (char *)0)
    free(client->reply.msg);

  client->reply.msg = (char *)malloc(CNTL_BUF_SIZE);
  if (client->reply.msg == (char *)0)
    return -1;

  client->reply.size=vsnprintf(client->reply.msg, CNTL_BUF_SIZE - 3, fmt, args);
  va_end(args);  /* cleanup argument list */

  strncat(client->reply.msg, "\r\n", CNTL_BUF_SIZE -  client->reply.size);
  client->reply.size += 2;
  client->reply.nwritten = 0;
  client->ostate = client->state;
  client->state = S_COMM_W;
  return client_reply(client);
}
