#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/mman.h>
#include <errno.h>
#include <time.h>

#include "yaftpd.h"
#include "client.h"
#include "server.h"
#include "log.h"


int
client_write(client)
CLIENT * client;
{
  int err =0;

  LOG(L_FUNC, ("client_write() call:"));
/* if file not mmap() */
  if (client->file.cursor == (caddr_t)-1)
  {
    client->file.nwritten = client->file.size;
    --err;
    goto finish;
  }

/* try to write a chunk */
  if (client->file.nwritten < client->file.size)
  {
    off_t nwrite;
    nwrite = write(client->sock_dat,
                   client->file.cursor + client->file.nwritten,
                   client->file.size - client->file.nwritten);
    if (nwrite > 0)
      client->file.nwritten += nwrite;
    else
      switch(errno)
      {
        case EAGAIN:
        break;
        default: /* error finish sending */
          client->file.nwritten = client->file.size;
          err--;
      }
  }

finish:
/* finish sending */
  if (client->file.nwritten == client->file.size)
  {
    time_t now;
    time(&now);
    LOG(L_DOWN, ("D %s %s %ld, %s %s",
              ctime(&now),
              (client->file.name == (char *)0) ? "(null)": client->file.name, 
              (long)client->file.size,
              inet_ntoa(client->addr.sin_addr),
              (client->user == (char *)0) ? "(null)": client->user)); 
    if (client->file.cursor != (caddr_t)-1)
       MUNMAP(client);
    if (client->file.name != (char *)NULL)
      free(client->file.name);
    client->file.name = (char *)NULL;
    client->file.nwritten = client->file.size = 0;
    client->sock_dat > 0 && close(client->sock_dat);
    client->state = S_COMM;
    reply(client, "%d Closing data con, transfer ok", 226);
    err--;
  }
  return err;
}
