/*  exemple taken from GNU Readline library. */
#include "cmd.h"

/* Look up NAME as the name of a command, and return a pointer to that
   command.  Return a NULL pointer if NAME isn't a command name. */
COMMAND *
find_command (name, commands)
char *name;
COMMAND commands[];
{
  register int i;

  name = stripwhite(name);

  for (i = 0; commands[i].name; i++)
    if (STRCMP(name, commands[i].name) == 0)
      return (&commands[i]);

  return ((COMMAND *)NULL);
}

/* Strip whitespace from the start and end of STRING.  Return a pointer
   into STRING. */
char *
stripwhite (string)
char *string;
{
  register char *s, *t;

  if (string == (char *)0)
    return string;

  for (s = string; isspace(*s); s++)
     ;
    
  if (*s == 0)
    return (s);

  t = s + strlen (s) - 1;
  while (t > s && isspace (*t))
    t--;
  *++t = '\0';

  return s;
}
