#include <sys/types.h> /* size_t and misc */
#include <sys/stat.h> /* stat() and macros */
#include <time.h> /* struct tm , strftime()*/
#include <string.h> /* strchr() and friends */

#define FORMAT(e, rwx, t, f, i) rwx[i] = ((e) != 0) ? t : f

/* formating 'drwxrwxrwx' */
#define URWX(mode, rwx, i) \
  FORMAT(S_IRUSR & mode, rwx, 'r', '-', ++i); \
  FORMAT(S_IWUSR & mode, rwx, 'w', '-', ++i); \
  FORMAT(S_IXUSR & mode, rwx, 'x', '-', ++i)

#define GRWX(mode, rwx, i) \
  FORMAT(S_IRGRP & mode, rwx, 'r', '-', ++i); \
  FORMAT(S_IWGRP & mode, rwx, 'w', '-', ++i); \
  FORMAT(S_IXGRP & mode, rwx, 'x', '-', ++i)

#define ORWX(mode, rwx, i) \
  FORMAT(S_IROTH & mode, rwx, 'r', '-', ++i); \
  FORMAT(S_IWOTH & mode, rwx, 'w', '-', ++i); \
  FORMAT(S_IXOTH & mode, rwx, 'x', '-', ++i)

extern int snprintf();
static char timef[100];
static char rwx[11];

int format(opt, file, buffer, len)
char * opt;
char * file;
char * buffer;
int len;
{
  struct stat stbuf;
  struct tm *ptm;
  int i;

  if (file == (char *)0)
  {
    *buffer = '\0';
    return 0;
  }

  if (opt == (char *)0 || *opt == '\0')
    return snprintf(buffer, len, "%s\n", file);

  if (stat(file, &stbuf) < 0 || len < 45)
  {
      buffer[0] = '\0';
      return 0;  /* ???? */
  }

/* long listing */
  if (strchr(opt, 'l') != (char *)0)
  {
    if (S_ISREG(stbuf.st_mode))
      rwx[0] = '-';
    else if (S_ISLNK(stbuf.st_mode))
      rwx[0] = 'l';
    else if (S_ISDIR(stbuf.st_mode))
      rwx[0] = 'd';
    else
    {
      *buffer = '\0';
      return 0;  /* only show files and directories */
    }

    i = 0;
    URWX(stbuf.st_mode, rwx, i);
    GRWX(stbuf.st_mode, rwx, i);
    ORWX(stbuf.st_mode, rwx, i);
    rwx[++i] ='\0';

    ptm = localtime(&stbuf.st_mtime);
    strftime(timef, sizeof(timef), "%b %e %k:%m %Y ", ptm);

    return snprintf(buffer, len, "%s %2d %s %10ld %s %s\n",
                    rwx, stbuf.st_nlink, "ftp", stbuf.st_size, timef, file);

  }
/* minimal mimic of -F option */
  if (strchr(opt, 'F') != (char *)0)
    if (S_ISDIR(stbuf.st_mode))
      return snprintf(buffer, len, "%s/\n", file);
    else
      return snprintf(buffer, len, "%s\n", file);

/* catch all */
  return 0;
}

#ifdef DRIVER
#include <stdio.h>

void main(argc, argv)
int argc;
char **argv;
{
  char line[1024];
  int i;

  i = format("-l", argv[1], line, 1024, 1);
  printf("%s", line);
}
#endif
