#include <string.h>
#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <errno.h>

#include "yaftpd.h"
#include "client.h"
#include "log.h"

int
ftp_cwd(arg, client)
char * arg;
CLIENT * client;
{
  struct stat st;
  char * path;
  char * cwd;

  LOG(L_FUNC, ("ftp_cwd() call:"));
  LOG(L_COMM, ("  CWD %s", (arg == NULL) ? "(null)" : arg));

  if (client->auth <= 0)
  {
    LOG(L_DENY, (" not login, denied"));
    reply(client, "%d Not logged in", 530);
    return -1;
  }

  if (arg == (char *)0 || *arg == 0)
    return reply(client, "%d Command Ok", 250);

/* filter path */
  if (arg[0] == '/')
    path = path_filter((char *)0, arg);
  else
    path = path_filter(client->cwd, arg);

  if (path == (char *)0)
    return reply(client, "%d local error, out of mem", 451);

  cwd = (char *)malloc(strlen(path) + strlen(client->root) + 2 + 1);
  if (cwd == (char *)0)
  {
    free(path);
    return reply(client, "%d local error, out of mem", 451);
  }
/* we use the <path>/. trick to pass some specific OS ACL */
  sprintf(cwd, "%s%s/.", client->root, path);

  if (stat(cwd, &st) != 0)
  {
    free(path);
    free(cwd);
    return reply(client, "%d can't stat dir %s", 550, strerror(errno));
  }

  if (client->cwd != (char *)0)
    free(client->cwd);
  client->cwd = path;
  LOG(L_PATH, ("  Filter path: %s", (path == NULL) ? "(null)" : path));
  return reply(client, "%d Command Ok", 250);
} 
