#include <string.h>
#include <stdlib.h>

#include "yaftpd.h"
#include "client.h"
#include "log.h"

int
ftp_pass(arg, client)
char * arg;
CLIENT * client;
{
  LOG(L_FUNC, ("ftp_pass() call:"));

  LOG(L_COMM, ("  PASS %s", (arg == NULL) ? "(null)" : arg));

  if (arg == (char *)0)
    return reply(client, "%d Syntax error in parameter", 501);

  if (client->user == (char *)0)
    return reply(client, "%d Need username ", 332);

  if (client->auth > 0)
  {
    reply(client, "%d User loggin, proceed", 230);
    return 1;
  }

  if (strcmp(client->user, "ftp") == 0 || 
      strcmp(client->user, "anonymous") == 0)
  {
    client->auth = AUTH_ANON;
    client->passwd = (char *)strdup(arg);
    return reply(client, "%d User logged in, proceed", 230);
  }

#ifdef ANON_FTP

  reply(client, "%d anonymous loggin only", 530);
  client->state = S_FIN;
  return -1;

#else

/* do the 
 * crypt/shadow/PAM 
 * whatever stuff here
 */

  client->auth = AUTH_USER;
  if (client->root != (char *)0) 
    free(client->root);
  client->root = (char *)strdup("/");
  client->passwd = (arg[0] == '-') ? 
                   (char *)strdup("-XXX") :
                   (char *)strdup("XXX");
  return reply(client, "%d User logged in, proceed", 230);
#endif
    
} 
