#include <sys/types.h>
#include <sys/stat.h>

#include "yaftpd.h"
#include "client.h"
#include "log.h"

int
ftp_size(arg, client)
char * arg;
CLIENT * client;
{
  struct stat stbuf;

  LOG(L_FUNC, ("ftp_size() call:"));
  LOG(L_COMM, ("  SIZE %s", (arg == NULL) ? "(null)" : arg));

  if (client->auth <= 0)
  {
    LOG(L_DENY, (" not login, denied"));
    reply(client, "%d Not logged in", 530);
    return -1;
  }

  if (arg == (char *)0)
  {
    reply(client, "%d Syntax error in parameter", 501);
    return -1;
  }

  if (! client->auth)
    return reply(client, "%d Not log in ", 530);

  if (stat(arg, &stbuf) < 0 || !(S_ISREG(stbuf.st_mode)))
    return reply(client, "%d %s: not a plain file.", 550, arg);
  
  return reply(client, "%d %ld", 213, stbuf.st_size);
}
