#include <string.h>

#include "yaftpd.h"
#include "client.h"
#include "log.h"

#define STRCMP(a, b) *a == *b && strcmp(a, b)

int
ftp_user(name, client)
char * name;
CLIENT * client;
{
  LOG(L_FUNC, ("ftp_user() call:"));

  LOG(L_COMM, ("  USER %s", (name == NULL) ? "(null)" : name));

  if (name == NULL)
  {
    reply(client, "%d Syntax error in parameter", 501);
    return -1;
  }

  if (client->auth)
  {
    reply(client, "%d User loggin, proceed", 230);
    return 1;
  }
    
  client->user = (char *)strdup(name);
  if (client->user == NULL) return -1;

  if ((STRCMP(name, "ftp") == 0) || (STRCMP(name, "anonymous") == 0))
    return reply(client, "%d User %s okay, give email as passwd", 331, name);

#ifdef ANON_FTP
  reply(client, "%d Anonymous loggin only ", 530);
  client->state = S_FIN;
  return -1;
#else;
  return reply(client, "%d Anonymous only, give email as passwd", 332);
#endif
}
