#ifndef _PARSECMD_H
#define _PARSECMD_H

#include "yaftpd.h"
#include "client.h"
#include "cmd.h"

static COMMAND commands[] = {
	{ "USER", ftp_user, "<sp> username" },
	{ "PASS", ftp_pass, "<sp> password" },
	{ "LIST", ftp_list, "[ <sp> path-name ]" },
	{ "NLST", ftp_list, "[ <sp> path-name ]" },
	{ "PWD",  ftp_pwd,  "(return current directory)" },
	{ "CWD",  ftp_cwd,  "[ <sp> directory-name ]" },
	{ "CDUP", ftp_cdup, "(change to parent directory)" },
	{ "RETR", ftp_retr, "<sp> file-name" },
	{ "PASV", ftp_pasv, "(set server in passive mode)" },
	{ "PORT", ftp_port, "<sp> b0, b1, b2, b3, b4" },
	{ "TYPE", ftp_type, "<sp> [ A | E | I | L ]" },
	{ "MODE", not_done, "(specify transfer mode)" },
	{ "REST", not_done, "<sp> offset (restart command)" },
	{ "SITE", not_done, "site-cmd [ <sp> arguments ]" },
	{ "SYST", ftp_syst, "(get type of operating system)" },
	{ "HELP", not_done, "[ <sp> <string> ]" },
	{ "QUIT", ftp_quit, "(terminate service)", },
	{ "SIZE", ftp_size, "<sp> path-name" },
	{ "DELE", not_done, "<sp> file-name" },
	{ "STOR", not_done, "<sp> file-name" },
	{ "ABOR", not_done, "(abort operation)" },
	{ "MKD",  not_done,  "<sp> path-name" },
	{ "RMD",  not_done,  "<sp> path-name" },
	{ "NOOP", not_done, "" },
	{ "STAT", not_done, "[ <sp> path-name ]" },
	{ "MDTM", not_done, "<sp> path-name" },
	{ "RNFR", not_done, "<sp> file-name" },
	{ "RNTO", not_done, "<sp> file-name" },
	{ "REIN", not_done, "(reinitialize server state)" },
	{ "ACCT", not_done, "(specify account)" },
	{ "APPE", not_done, "<sp> file-name" },
	{ "ALLO", not_done, "allocate storage (vacuously)" },
	{ "XCWD", not_done,	"[ <sp> directory-name ]" },
	{ "XMKD", not_done,  "<sp> path-name" },
	{ "XRMD", not_done,  "<sp> path-name" },
	{ "XPWD", not_done,  "(return current directory)" },
	{ "XCUP", not_done, "(change to parent directory)" },
	{ "STOU", not_done, "<sp> file-name" },
	{ "STRU", not_done, "(specify file structure)" },
	{ "MLFL", not_done, "(mail file)" },
	{ "MAIL", not_done, "(mail to user)" },
	{ "SMNT", not_done, "(structure mount)" },
	{ "MSND", not_done, "(mail send to terminal)" },
	{ "MSOM", not_done, "(mail send to terminal or mailbox)" },
	{ "MSAM", not_done, "(mail send to terminal and mailbox)" },
	{ "MRSQ", not_done, "(mail recipient scheme question)" },
	{ "MRCP", not_done, "(mail recipient)" },
  { (char *)NULL, (int (*)())NULL, (char *)NULL }
};

#endif /* _PARSECMD_H */
