#include <sys/types.h>
#include <string.h>
#include <fcntl.h>
#include <errno.h>

/* for telnet */
#define IAC     255             /* interpret as command: */
#define DONT    254             /* you are not to use option */
#define DO      253             /* please, you use option */
#define WONT    252             /* I won't use option */
#define WILL    251             /* I will use option */

#define MAX_CHARS 128

extern int errno;
extern int cntrl;

static int
telnetchar(fd, buf)
int fd;
unsigned char *buf;
{
  char respond[4];

  switch (buf[0]) {
    case WILL:
    case WONT:
      respond[0] = IAC; respond[1] = DONT; 
      respond[2] = buf[1]; respond[3] = '\0';
      break;
    case DO:
    case DONT:
      respond[0] = IAC; respond[1] = WONT; 
      respond[2] = buf[1]; respond[3] = '\0';
    case IAC:
    default:
      respond[0] = '\0';
      break;
  }

  (respond[0] != '\0') && write(fd, respond, strlen(respond));

  return 1;
}

int readline(fd, s, lim)
int fd;
char *s;
int lim;
{
  int n, nc;
  char * sp = s;
  unsigned char buf[MAX_CHARS];

  do
    nc = read(fd, buf, sizeof(buf));
  while ((nc < 0) && (errno == EINTR));

  for (n = 0; n < nc && n < lim - 1; n++)
    switch(buf[n]) {
      case IAC:
        (nc - n > 2) && telnetchar(fd, buf + n + 1);
        break;
      case '\r':
      case '\n':
        break;
      default:
        *s++ = buf[n];
    }
  
  *s = '\0';
  return nc;
}
