/* Taken from Andrew Grieth daemon functions
 *  Really minor editing
 */
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h> /* umask */
#include <sys/wait.h>
#include <stdio.h>
#include <errno.h>


#define GUESS 256

/* daemon() - detach process from user and disappear into the background
* returns -1 on failure, but you can't do much except exit in that case
* since we may already have forked. This is based on the BSD version,
* so the caller is responsible for things like the umask, etc.
*/

/* believed to work on all Posix systems */

int server_daemon(start)
int start;
{
  int fd, fdlimit;

  switch (fork())
  {
    case 0:  break;
    case -1: return -1;
    default: _exit(0);          /* exit the original process */
  }

  if (setsid() < 0) return -1;               /* shoudn't fail */

/* dyke out this switch if you want to acquire a control tty in */
/* the future - not normally advisable for daemons */

  switch (fork())
  {
    case 0:  break;
    case -1: return -1;
    default: _exit(0);
  }

/* close all FDs >= a specified value */

  fdlimit = sysconf(_SC_OPEN_MAX);
  if (fdlimit < 0) fdlimit = GUESS;

  for (fd = start; fd < fdlimit; fd++) close(fd);

  umask(0);
  return 0;
}

#ifdef DRIVER
#include <unistd.h>
int main()
{
  int fd;
  FILE *fp;
  char buf[10];

  if (server_daemon(0) < 0)
  {
    printf("daemon");
    exit(2);
  }

  fd = open("/tmp/test", O_TRUNC|O_CREAT|O_WRONLY);
  sprintf(buf, "test %d\n", fd);
  write(fd, buf, strlen(buf));

  fp = (FILE *)fdopen(fd, "w");
  if (fp == NULL)
    write(fd, "problem\n", 8);
  else
  {
    fprintf(fp, "Perfect timing : %d\n", fd);
    fflush(fp);
  }

  sleep(2);
  return 0;
}
#endif
