#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>   /* define    INADDR_ANY */
#include <string.h>   /* memset */
#include <unistd.h>  /* close */

#ifndef LISTENQ
#  define LISTENQ 10
#endif

/* the usual setup:
    socket()/setsockpt()/bind()/listen()
   I don't do the accept(). It's handle
   by another layer with select()/accept()
 */
int
server_open(port)
long port;
{
  struct sockaddr_in address;
  int sock;
  int o;
  int err = 0;

/*  bzero((char *) &address, sizeof(address)); */
  memset((char *) &address, 0, sizeof(address));
  address.sin_family = AF_INET;
  address.sin_port = htons(port);
  address.sin_addr.s_addr = htonl(INADDR_ANY);

  sock = socket(AF_INET, SOCK_STREAM, 0);
  if (sock < 0) return sock;

  o = 1;
  if (setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, (char *)&o, sizeof(o)) < 0)
    err++;
 
  o = 1;
  if (setsockopt(sock, SOL_SOCKET, SO_OOBINLINE, (char *)&o, sizeof(o)) < 0)
    err++;

  if (bind(sock, (struct sockaddr *) &address, sizeof(address)) < 0) err++;

  listen(sock, LISTENQ);

  if (err)
  {
    close(sock);
    sock = -1;
  }

  return(sock);
}

#ifdef DRIVER

#ifndef PORT
#  define PORT 2005
#endif

/* simple echo program to test servopen */
void main()
{
  int sock;
  int n = 1;
  char buf[100];

  sock = server_open(PORT);
  if (sock > 0)
  {
    int fd;
   
    fd = accept(sock, 0, 0);
    while(n != 0)
    {
      n = read(fd, buf, 100);
      write(fd, buf, n);
      write(0, buf, n);
    }
  }
  else printf("error in servopen %d\n", sock);
} 
#endif /* DRIVER */
