#include <unistd.h>
#include <stdio.h> /* I/O std */
#include <stdlib.h> /* getopt() extern optarg */
#include <fcntl.h> /* open() */
#include <errno.h>

#include "yaftpd.h"
#include "server.h"
#include "log.h"

static int daemonize;
#ifndef LOGFILE
#define LOGFILE "YAFTPD"
#endif
char * logfile = LOGFILE;

#ifndef CONFILE
#define CONFILE "yaftpd.conf"
#endif
static char * confile = CONFILE;

#ifndef PORT
#define PORT 21
#endif
long port = PORT;

static SERVER server;

static int
bye (s)
char *s;
{
  fprintf(stderr, "%s: %s\n", s, strerror(errno));
  exit(-1);
  return 1;
}

/*
 * initialization of defaults for server 
 */
static void
server_def(server)
SERVER *server;
{
  server->uid = getuid();
  server->gid = getgid();
  server->root = getcwd((char *)0, 100 - 1);
  server->banner = -1;
}

void
main(argc, argv)
int argc;
char **argv;
{
  extern char * optarg;
  int i;
  
  while ((i = getopt(argc, argv, "dc:")) != EOF)
  {
    switch(i)
    {
      case 'd': /* daemonize ? */
        daemonize = 1;
      break;
      case 'c':
        confile = optarg;
      break;
      default:
        bye("usage: -c [yaftpd.conf] -d [daemonize]");
    }
  }

/* read config file */
  server_def(&server);
  server_cfg(confile, &server) < 0 && bye("config file error");

/* signals */
  signal_handler();

  chdir(server.root) < 0 && bye("can't change dir");

/* double fork() to be daemon */
  daemonize && server_daemon(0) < 0 && bye("deamon error");

/* set up tcp connection */
  (server.sockfd = server_open(port)) < 0 && bye("unable to set up tcp");

printf("log: %s\n");
  initlog(logfile);
  loglevel = 20;
  LOG(1, ("\nStart log"));

/* start parsing cmd, never return */
  server_loop(&server);

/* NOT REACHED */
  exit(0);
}
